## Version 4.6.0

### Feature

#### general
- Add sort_by optional string field for the below data sources in cloudapi and cloudbroker:

| group     | cloudapi data sources                                                                                                                                                                                        | cloudbroker data sources                                                                                                                                                                                                           |
|-----------|--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|
| account   | decort_account_computes_list</br>decort_account_deleted_list</br>decort_account_disks_list</br>decort_account_list</br>decort_account_rg_list</br>decort_account_templates_list</br>decort_account_vins_list | decort_cb_account_computes_list</br>decort_cb_account_disks_list</br>decort_cb_account_flipgroups_list</br>decort_cb_account_list</br>decort_cb_account_list_deleted</br>decort_cb_account_rg_list</br>decort_cb_account_vins_list |
| audit | - | decort_cb_audit_list                                                                                                                                                                                                               |
| bservice  | decort_bservice_deleted_list</br>decort_bservice_list                                                                                                                                                        | -                                                                                                                                                                                                                                  |
| disk      | decort_disk_list</br>decort_disk_list_types</br>decort_disk_list_types_detailed</br>decort_disk_list_unattached</br>decort_disk_list_deleted                                                                 | decort_cb_disk_list</br>decort_cb_disk_list_deleted</br>decort_cb_disk_list_types</br>decort_cb_disk_list_types_detailed</br>decort_cb_disk_list_unattached                                                                        |
| extnet    | decort_extnet_computes_list</br>decort_extnet_list                                                                                                                                                           | decort_cb_extnet_list                                                                                                                                                                                                              |
| flipgroup | decort_flipgroup_list                                                                                                                                                                                        | decort_cb_flipgroup_list                                                                                                                                                                                                           |
| grid | - | decort_cb_grid_list                                                                                                                                                                                                                |
| image     | decort_image_list                                                                                                                                                                                            | decort_cb_image_list</br>decort_cb_image_list_stacks                                                                                                                                                                               |
| k8ci      | decort_k8ci_list                                                                                                                                                                                             | decort_cb_k8ci_list</br>decort_cb_k8ci_list_deleted                                                                                                                                                                                |
| k8s       | decort_k8s_list</br>decort_k8s_list_deleted                                                                                                                                                                  | decort_cb_k8s_list</br>decort_cb_k8s_list_deleted                                                                                                                                                                                  |
| kvmvm | decort_kvmvm_list</br>decort_kvmvm_list_deleted</br>decort_kvmvm_pci_device_list</br>decort_kvmvm_vgpu_list                                                                                                  | decort_cb_kvmvm_list</br>decort_cb_kvmvm_list_deleted</br>decort_cb_kvmvm_pci_device_list</br>decort_cb_kvmvm_vgpu_list                                                                                                            |
| lb | decort_lb_list</br>decort_lb_list_deleted                                                                                                                                                                    | decort_cb_lb_list</br>decort_cb_lb_list_deleted                                                                                                                                                                                    |
| locations | decort_locations_list                                                                                                                                                                                        | -                                                                                                                                                                                                                                  |
| rg | decort_rg_list</br>decort_rg_list_computes</br>decort_rg_list_deleted</br>decort_rg_list_lb</br>decort_rg_list_vins                                                                                                             | decort_cb_rg_list</br>decort_cb_rg_list_computes</br>decort_cb_rg_list_deleted</br>decort_cb_rg_list_lb</br>decort_cb_rg_list_vins                                                                                                 |
| sep | - | decort_cb_sep_list                                                                                                                                                                                                                 |
| stack | decort_stack_list | decort_cb_stack_list                                                                                                                                                                                                               |
| vfpool | decort_vfpool_list | decort_cb_vfpool_list |
| vins | decort_vins_list</br>decort_vins_list_deleted | decort_cb_vins_list</br>decort_cb_vins_list_deleted                                                                                                                                                                                                           |

#### account:
- Add available_templates optional field to resource decort_cb_account in cloudbroker/account
- Add data source decort_cb_account_available_templates_list in cloudbroker/account
- Add compute_features computed fields to data sources decort_account, decort_account_list, decort_account_deleted_list, decort_cb_account, decort_cb_account_list, decort_account_deleted_list and to resource decort_account in cloudapi/account and cloudbroker/account
- Add compute_features optional field to resource decort_cb_account in cloudbroker/account
- Add extnet_id, free_ips computed fields to data sources decort_account_vins_list and decort_cb_account_vins_list in cloudapi/account and cloudbroker/account

#### audit:
- Add guid computed field to data source decort_cb_audit_linked_jobs in cloudbroker/audit
- Delete field status_code in data source decort_cb_audit_list in cloudbroker/audit
- Add fields min_status_code and max_status_code in data source decort_cb_audit_list in cloudbroker/audit

#### bservice:
- Add validation of ram to be divisible by 128 to resource decort_bservice_group in cloudapi/bservice

#### disks:
- Add resource and data source decort_disk_replication and decort_cb_disk_replication
- Add field replication in data sources and resource decort_disk, decort_disk_list, decort_disk_list_deleted, decort_cb_disk, decort_cb_disk_list, decort_cb_disk_list_deleted
- Add node_ids optional field to resource decort_cb_disk in cloudbroker/disk

#### flipgroup:
- Add conn_id, status and account_id optional fields to data sources decort_flipgroup_list and decort_cb_flipgroup_list in cloudapi/flipgroup and cloudbroker/flipgroup
- Add client_ids optional fields to data sources decort_flipgroup_list and decort_cb_flipgroup_list in cloudapi/flipgroup and cloudbroker/flipgroup

#### kvmvm:
- Add cd_image_id computed field to data sources decort_kvmvm, decort_kvmvm_list, decort_cb_kvmvm, decort_cb_kvmvm_list and resourced decort_kvmvm, decort_cb_kvmvm in cloudapi/kvmvm and cloudbroker/kvmvm
- Add natable_vins_id, natable_vins_ip, natable_vins_name, natable_vins_network and natable_vins_network_name computed fields to data source decort_cb_kvmvm and to resource decort_cb_kvmvm in cloudbroker/kvmvm
- Change field local_port (in block port_forwarding) from required to optional in resources decort_kvmvm and decort_cb_kvmvm in cloudapi/kvmvm and cloudbroker/kvmvm
- Add hp_backed, cpu_pin, numa_affinity and numa_node_id computed fields to data sources decort_kvmvm, decort_kvmvm_list, decort_cb_kvmvm, decort_cb_kvmvm_list in cloudapi/kvmvm and cloudbroker/kvmvm
- Add hp_backed, cpu_pin, numa_affinity optional fields and numa_node_id computed field to resources decort_kvmvm, decort_cb_kvmvm in cloudapi/kvmvm and cloudbroker/kvmvm
- Add validation of ram to be divisible by 128 to resources decort_kvmvm and decort_cb_kvmvm in cloudapi/kvmvm and cloudbroker/kvmvm
- Add name optional field to data source decort_cb_kvmvm_pci_device_list in cloudbroker/kvmvm
- Add fields image_name and virtual_image_name in resource and data source decort_cb_kvmvm in cloudbroker/kvmvm
- Add fields enabled and node_id in resource and data sources decort_cb_kvmvm, decort_cb_kvmvm_list, decort_cb_kvmvm_list_deleted in cloudbroker/kvmvm. Add field node_id in resource and data sources decort_kvmvm, decort_kvmvm_list, decort_kvmvm_list_deleted in cloudapi/kvmvm
- Delete network and extra_disk fields in data source decort_cb_kvmvm in cloudbroker/kvmvm
- Add computed fields compute_id, description, guid, hwpath, device_id, name, rg_id, stack_id, status, system_name in data source decort_kvmvm_pci_device_list in cloudapi/kvmvm
- Add computed fields account_id, created_time, deleted_time, gid, guid, vgpu_id, last_claimed_by, last_update_time, mode, pci_slot, pgpuid, profile_id, ram, reference_id, rg_id, status, type, vm_id in data sources decort_kvmvm_vgpu_list and decort_cb_kvmvm_vgpu_list in cloudapi/kvmvm and cloudbroker/kvmvm
- Add field replication (disk_id, pool_id, role, self_volume_id, storage_id, volume_id) in data source decort_kvmvm, decort_cb_kvmvm in cloudapi/kvmvm and cloudbroker/kvmvm
- Add computed field reserved_node_cpus in data sources decort_kvmvm, decort_kvmvm_list, decort_kvmvm_list_deleted, decort_cb_kvmvm, decort_cb_kvmvm_list, decort_cb_kvmvm_list_deleted and in resources decort_kvmvm, decort_cb_kvmvm in cloudapi/kvmvm and cloudbroker/kvmvm
- Add "VFNIC" as allowed net_type value in network block for resources decort_kvmvm and decort_cb_kvmvm (created with "KVM_X86" driver) in cloudapi/kvmvm and cloudbroker/kvmvm
- Set optional field image_id in resource decort_kvmvm, decort_cb_kvmvm in cloudapi/kvmvm and cloudbroker/kvmvm
- Add optional field without_boot_disk in resource decort_kvmvm, decort_cb_kvmvm in cloudapi/kvmvm and cloudbroker/kvmvm
- Add optional fields depresent, node_ids in resource decort_cb_kvmvm in cloudbroker/kvmvm

#### image:
- Add cd_presented_to computed field to data sources decort_image, decort_cb_image and to resources decort_image, decort_cb_image in cloudapi/image and cloudbroker/image
- Add account_id required field to resource decort_image in cloudapi/image
- Add accounts optional field to resource decort_cb_image in cloudbroker/image
- Add  network_interface_naming computed field to data sources decort_image, decort_image_list, decort_cb_image, decort_cb_image_list and to resources decort_image, decort_cb_image in cloudapi/image and cloudbroker/image
- Delete gid required field from resource decort_image in cloudapi/image
- Delete meta and ckey computed fields from data sources and resource decort_cb_image and decort_cb_image_list in cloudbroker/image
- Add resource decort_image_from_blank_compute and decort_cb_image_from_blank_compute in cloudapi/compute and cloudbroker/compute
- Add resource decort_image_from_platoform_disk and decort_cb_image_from_platoform_disk in cloudapi/compute and cloudbroker/compute
- Add file_path optional field to resource decort_cb_image in cloudbroker/image
- Сhanged url field from required to optional in resource decort_cb_image in cloudbroker/image

#### k8s:
- Change lb_sysctl_params optional field from string to array in resources decort_k8s and decort_k8s_cp in cloudapi/k8s
- Add lb_sysctl_params optional field to resource decort_cb_k8s_cp in cloudbroker/k8s
- Add validation of ram to be divisible by 128 to resources decort_k8s, decort_k8s_cp, decort_k8s_wg, decort_cb_k8s_cp and decort_cb_k8s_wg in cloudapi/k8s and cloudbroker/k8s
- Change possible values num field (can be 5) in resources decort_k8s(cloudapi/k8s), decort_k8s_cp(cloudapi/k8s) and decort_cb_k8s_cp(cloudbroker/k8s)

#### lb:
- Add user_managed, manager_id, manager_type and part_k8s computed fields to data sources decort_lb, decort_lb_list, decort_cb_lb, decort_cb_lb_list and to resources decort_lb, decort_cb_lb in cloudapi/lb and cloudbroker/lb
- Add sysctl_params optional field to resources decort_lb and decort_cb_lb in cloudapi/lb and cloudbroker/lb
- Add safe optional field to resource decort_cb_lb in cloudbroker/lb

#### node:
- Add data sources decort_cb_node and decort_cb_node_list in cloudbroker/node

#### rg:
- Add compute_features computed fields to data sources decort_resgroup, decort_rg_list, decort_rg_list_deleted, decort_cb_rg, decort_cb_rg_list, decort_cb_rg_list_deleted and to resource decort_resgroup in clouapi/rg and cloudbroker/rg
- Add compute_features optional field to resource decort_cb_rg in cloudbroker/rg
- Add extnet_id, free_ips computed fields to data sources decort_rg_vins_list and decort_cb_rg_vins_list in cloudapi/rg and cloudbroker/rg
- Change resource quota handling logic in cloudapi to be like cloudbroker's. Added "cu_d" field into cloudapi resource quota schema. Deleted default values of "cpu", "ram", "disk", "ext_traffic", "ext_ips" and "gpu_units" fields in cloudapi resource schema

#### sep:
- Add pools optional field to resource decort_cb_sep in cloudbroker/sep
- Change config field from optional to required in resource decort_cb_sep in cloudbroker/sep

#### user:
- Add data sources decort_cb_user, decort_cb_user_list and decort_cb_user_get_audit in cloudbroker/user
- Add resource decort_cb_user in cloudbroker/user

#### vfpool:
- Add data sources decort_vfpool, decort_vfpool_list and decort_cb_vfpool, decort_cb_vfpool_list in cloudapi/vfpool and cloudbroker/vfpool
- Add resource decort_cb_vfpool in cloudbroker/vfpool

#### vins:
- Change field int_port (in block nat_rule) from required to optional in resource decort_cb_vins in cloudbroker/vins
- Add extnet_id, free_ips computed fields to data sources decort_vins_list, decort_cb_vins_list in cloudapi/vins and cloudbroker/vins
- Add dns optional field to resources decort_vins and decort_cb_vins in cloudapi/vins and cloudbroker/vins
- Add node_id computed field to resources and data sources decort_vins and decort_cb_vins in cloudapi/vins and cloudbroker/vins
- Add vnfdev_id optional field to data sources decort_cb_vins_list in cloudbroker/vins
- Add vnfdev_id optional field to data sources decort_vins_list_deleted in cloudapi/vins

### Bugfix
- Fix boot_disk_size field to be saved correctly in state in order to stop unnecessary resource update attempts after `terraform apply` in resource decort_cb_kvmvm in cloudbroker/kvmvm
- Rename computed field name to k8s_name in order to fix state in data source decort_k8s_list_deleted in cloudapi/k8s
- Delete account_id field in data sources decort_rg_list_lb and decort_cb_rg_list_lb in cloudapi/rg and cloubroker/rg
