/*
Пример использования
Ресурса sep
Ресурс позволяет:
1. Создавать sep.
2. Редактировать sep.
3. Удалять sep.
4. Конфигурировать sep.
*/

#Расскомментируйте код ниже,
#и внесите необходимые правки в версию и путь,
#чтобы работать с установленным вручную (не через hashicorp provider registry) провайдером
/*
terraform {
  required_providers {
    decort = {
      source  = "basis/decort/decort"
      version = "<VERSION>"
    }
  }
}
*/

provider "decort" {
  authenticator = "decs3o"
  #controller_url = <DECORT_CONTROLLER_URL>
  controller_url = "https://ds1.digitalenergy.online"
  #oauth2_url = <DECORT_SSO_URL>
  oauth2_url           = "https://sso.digitalenergy.online"
  allow_unverified_ssl = true
}

resource "decort_cb_sep" "s" {
  #grid id
  #обязательный параметр
  #тип - целое число
  gid = 212

  #sep name
  #обязательный параметр
  #тип - строка
  name = "test sep"

  #тип sep
  #обязательный параметр
  #возможные значения - des, dorado, tatlin, hitachi
  #тип - строка
  type = "des"

  #конфигурация sep
  #обязательный параметр
  #мб применен при создании или редактировании sep
  #представляет собой json-строку
  #тип - строка
  config = file("./config.json")

  #описание sep
  #опциональный параметр
  #используется при создании ресурса
  #тип - строка
  #desc = "rrrrr"

  #изменение поля в конфигурации
  #опциональный параметр
  #может быть применен на уже созданном sep
  #внимание, во избежание конфликтов не использовать с полем config
  #тип - блок поля
  #field_edit {
    #имя поля
    #обязательный параметр
    #тип - строка
    #field_name = "edgeuser_password"

    #значение поля
    #обязательный параметр
    #тип - json строка
    #field_value = "mosk"

    #тип значения
    #обязательный параметр
    #возможные значения: list,dict,int,bool,str
    #тип - строка
    #field_type = "str"
  #}

  #предоставление/отключение доступа указанных аккаунтов к sep
  #опциональный параметр, используется при редактировании и создании ресурса
  #тип - массив целых чисел
  #account_ids = [12, 245]

  #предоставление/отключение доступа к пулу на sep
  #опциональный параметр, может быть применен на уже созданном sep
  #тип - блок доступа к пулу
  #access_to_pool {
    #имя pool
    #обязательный параметр
    #тип - строка
    #pool_name  = "pool name"

    #id аккаунта
    #опциональный параметр
    #тип - целое число
    #account_id_pool = 123

    #id ресурсной группы
    #опциональный параметр
    #тип - целое число
    #rg_id = 1234
  #}

  #доступность sep
  #опциональный параметр
  #может быть применен на уже созданном ресурсе
  #по умолчанию - false
  #тип - булев
  #enable = false

  #использование нодами
  #опциональный параметр
  #используется при редактировании и создании ресурса
  #тип - массив целых чисел
  #consumed_by = []

  #обновление лимита объема
  #опциональный параметр
  #применяется на уж созданном ресурсе
  #тип - булев
  #upd_capacity_limit = true

  #id provided nodes
  #опциональный параметр
  #используется при редактировании и создании ресурса
  #тип - массив целых чисел
  #provided_by = [16, 14, 15]

  #отключение nodes
  #опциональный параметр
  #применяется на уже созданном ресурсе
  #используется в связке с clear_physically
  #по умолчанию - true
  #тип - булев
  #decommission = true

  #физическое очищение nodes
  #опциональный параметр
  #используется при удалении ресурса
  #внимание, во избежание конфликтов использовать только в связке с полем decommission = true
  #тип - булев
  #clear_physically = false

  #добавление/удаление pools к/из sep 
  #опциональный параметр
  #используется при редактировании и создании ресурса, состоит из имен pool
  #тип - массив строк
  #pools = ["data01", "data02"]

}

output "test" {
  value = decort_cb_sep.s
}

output "config" {
  value = jsondecode(decort_cb_sep.s.config)
}
